package com.ibm.r2a.rules.rdj.examples.j2sebestpractices.synchronization;

public class SynchronizedMethod_Example {
	
	public synchronized int getNumber() {
		try { Thread.sleep( 3000 ); } catch (InterruptedException e) {}
		return number;
	}

	public synchronized String getString() {
		return str;
	}

	private String str = "Hello world!"; //$NON-NLS-1$
	private int number = 10;

	public static void main( String[] args ) {
		final SynchronizedMethod_Example data = new SynchronizedMethod_Example();
		Runnable numberReader = new Runnable() {
			public void run() {
				System.out.println( "Getting number..." ); //$NON-NLS-1$
				System.out.println( data.getNumber() );
			}
		};
		Runnable stringReader = new Runnable() {
			public void run() {
				System.out.println( "Getting string..." ); //$NON-NLS-1$
				System.out.println( data.getString() );
			}
		};
	
		(new Thread( numberReader ) ).start();
		(new Thread( stringReader ) ).start();
	}
	
}
